Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/expressionevaluator/impl/symboltable/DALSymbolTableFactory.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/expressionevaluator/impl/symboltable/DALSymbolTableFactory.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/expressionevaluator/impl/symboltable/DALSymbolTableFactory.java	(revision 44738)
@@ -0,0 +1,57 @@
+/**
+ * gvSIG. Desktop Geographic Information System.
+ *
+ * Copyright (C) 2007-2020 gvSIG Association.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; either version 3
+ * of the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
+ * MA  02110-1301, USA.
+ *
+ * For any additional information, do not hesitate to contact us
+ * at info AT gvsig.com, or visit our website www.gvsig.com.
+ */
+package org.gvsig.expressionevaluator.impl.symboltable;
+
+import org.gvsig.expressionevaluator.ExpressionEvaluatorLocator;
+import org.gvsig.expressionevaluator.ExpressionEvaluatorManager;
+import org.gvsig.expressionevaluator.SymbolTable;
+import org.gvsig.expressionevaluator.impl.DALFunctions;
+import org.gvsig.expressionevaluator.spi.AbstractSymbolTableFactory;
+
+/**
+ *
+ * @author jjdelcerro
+ */
+public class DALSymbolTableFactory extends AbstractSymbolTableFactory {
+
+    private SymbolTable symbolTable;
+    
+    public DALSymbolTableFactory() {
+        super(DALFunctions.SYMBOLTABLE_NAME, true);
+    }
+    
+    @Override
+    public SymbolTable create(Object... args) {
+        if( this.symbolTable==null ) {
+            this.symbolTable = new DALSymbolTable();
+        }
+        return this.symbolTable;
+    }
+    
+    public static final void selfRegister() {
+        ExpressionEvaluatorManager manager = ExpressionEvaluatorLocator.getManager();
+        
+        manager.registerSymbolTable(new DALSymbolTableFactory());
+    }
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/expressionevaluator/impl/symboltable/FeatureSymbolTableImpl.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/expressionevaluator/impl/symboltable/FeatureSymbolTableImpl.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/expressionevaluator/impl/symboltable/FeatureSymbolTableImpl.java	(revision 44738)
@@ -0,0 +1,183 @@
+/**
+ * gvSIG. Desktop Geographic Information System.
+ *
+ * Copyright (C) 2007-2020 gvSIG Association.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; either version 3
+ * of the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
+ * MA  02110-1301, USA.
+ *
+ * For any additional information, do not hesitate to contact us
+ * at info AT gvsig.com, or visit our website www.gvsig.com.
+ */
+package org.gvsig.expressionevaluator.impl.symboltable;
+
+import org.apache.commons.lang3.Range;
+import org.apache.commons.lang3.StringUtils;
+import org.gvsig.expressionevaluator.ExpressionEvaluatorLocator;
+import org.gvsig.expressionevaluator.ExpressionEvaluatorManager;
+import org.gvsig.expressionevaluator.Function;
+import org.gvsig.expressionevaluator.Interpreter;
+import org.gvsig.expressionevaluator.MutableSymbolTable;
+import org.gvsig.expressionevaluator.impl.DALFunctions;
+import org.gvsig.expressionevaluator.spi.AbstractFunction;
+import org.gvsig.expressionevaluator.spi.AbstractSymbolTable;
+import org.gvsig.fmap.dal.DataManager;
+import org.gvsig.fmap.dal.expressionevaluator.FeatureSymbolTable;
+import org.gvsig.fmap.dal.feature.Feature;
+import org.gvsig.fmap.dal.feature.FeatureAttributeDescriptor;
+import org.gvsig.fmap.dal.feature.FeatureStore;
+import org.gvsig.fmap.dal.feature.FeatureType;
+import org.gvsig.tools.dynobject.DynObject;
+import org.gvsig.tools.dynobject.DynObjectAdapter;
+import org.gvsig.tools.dynobject.exception.DynFieldNotFoundException;
+
+/**
+ *
+ * @author jjdelcerro
+ */
+@SuppressWarnings("UseSpecificCatch")
+public class FeatureSymbolTableImpl extends AbstractSymbolTable implements FeatureSymbolTable {
+
+  private final Function current_row;
+  private Feature feature;
+  private FeatureType type;
+  private String storeName;
+  private DynObject storeAdapter;
+
+  @SuppressWarnings("OverridableMethodCallInConstructor")
+  public FeatureSymbolTableImpl() {
+    super(DataManager.DAL_SYMBOL_TABLE_FEATURE);
+    this.current_row = new AbstractFunction(
+            DALFunctions.GROUP_DATA_ACCESS,
+            DALFunctions.FUNCTION_CURRENT_ROW,
+            Range.is(0),
+            "Return the current row when used in a table filter.\n"
+            + "Return null if used outer a table filter.",
+            DALFunctions.FUNCTION_CURRENT_ROW + "()",
+            null,
+            "Feature"
+    ) {
+      @Override
+      public Object call(Interpreter interpreter, Object[] args) throws Exception {
+        return feature;
+      }
+    };
+    this.storeAdapter = new DynObjectAdapter() {
+        @Override
+        public Object getDynValue(String name) throws DynFieldNotFoundException {
+          try {
+            return feature.get(name);
+          } catch (Exception ex) {
+            return feature.getExtraValue(name);
+          }
+        }
+
+        @Override
+        public boolean hasDynValue(String name) {
+          if( feature.getType().get(name)!=null ) {
+            return true;
+          }
+          return feature.hasExtraValue(name);
+        }
+        
+      };
+  }
+
+  @Override
+  public FeatureSymbolTableImpl clone() throws CloneNotSupportedException {
+    FeatureSymbolTableImpl other = (FeatureSymbolTableImpl) super.clone();
+    return other;
+  }
+
+  @Override
+  public Function function(String name) {
+    if (StringUtils.equalsIgnoreCase(name, DALFunctions.FUNCTION_CURRENT_ROW)) {
+      return this.current_row;
+    }
+    return super.function(name);
+  }
+
+  @Override
+  public boolean exists(String name) {
+    if (type == null) {
+      return false;
+    }
+    if ( type.get(name) != null) {
+      return true;
+    }
+    if (StringUtils.equalsIgnoreCase(name, this.storeName)) {
+      return true;
+    }
+    if( feature==null ) {
+      return false;
+    }
+    if (this.feature.hasExtraValue(name)) {
+      return true;
+    }
+    return false;
+  }
+
+  @Override
+  public Object value(String name) {
+    if (feature == null) {
+      return null;
+    }
+    if (StringUtils.equalsIgnoreCase(name, this.storeName)) {
+      return this.storeAdapter;
+    }
+    try {
+      return this.feature.get(name);
+    } catch (Exception ex) {
+      return this.feature.getExtraValue(name);
+    }
+  }
+
+  @Override
+  public boolean isSQLCompatible(String name) {
+    if (this.type == null) {
+      return super.isSQLCompatible(name);
+    }
+    FeatureAttributeDescriptor attrdesc = this.type.getAttributeDescriptor(name);
+    if (attrdesc == null) {
+      return true;
+    }
+    if (attrdesc.isComputed()) {
+      return false;
+    }
+    return true;
+  }
+
+  @Override
+  public void setFeature(Feature feature) {
+    this.feature = feature;
+    if (this.type == null) {
+      this.type = feature.getType();
+      FeatureStore store = feature.getStore();
+      if (store != null) {
+        this.storeName = store.getName();
+      }
+    }
+  }
+
+  @Override
+  public MutableSymbolTable createParent() {
+    ExpressionEvaluatorManager expManager = ExpressionEvaluatorLocator.getManager();
+
+    MutableSymbolTable symbolTable = expManager.createSymbolTable();
+    symbolTable.addSymbolTable(this);
+    return symbolTable;
+  }
+
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/DefaultFeature.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/DefaultFeature.java	(revision 44737)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/DefaultFeature.java	(revision 44738)
@@ -1176,6 +1176,10 @@
         return this.data.getExtraValue(name);
     }
 
+    public boolean hasExtraValue(String name) {
+        return this.data.hasExtraValue(name);
+    }
+    
     @Override
     public Object getExtraValue(int index) {
         return this.data.getExtraValue(index);
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/FeatureTypeToStoreProviderAdapter.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/FeatureTypeToStoreProviderAdapter.java	(revision 44737)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/FeatureTypeToStoreProviderAdapter.java	(revision 44738)
@@ -259,7 +259,13 @@
             @Override
             public void setExtraValueNames(String[] extraValueNames) {
             }
+
+            @Override
+            public boolean hasExtraValue(String name) {
+              return false;
+            }
             
+            
         }
         
         private final FeatureType featureType;
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/impl/DefaultDataManager.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/impl/DefaultDataManager.java	(revision 44737)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/impl/DefaultDataManager.java	(revision 44738)
@@ -18,6 +18,7 @@
 import org.gvsig.expressionevaluator.ExpressionBuilder;
 import org.gvsig.expressionevaluator.ExpressionEvaluatorLocator;
 import org.gvsig.expressionevaluator.MutableSymbolTable;
+import org.gvsig.expressionevaluator.impl.symboltable.FeatureSymbolTableImpl;
 import org.gvsig.fmap.dal.BaseStoresRepository;
 import org.gvsig.fmap.dal.DALLocator;
 
@@ -71,7 +72,6 @@
 import org.gvsig.fmap.dal.feature.spi.index.FeatureIndexProviderServices;
 import org.gvsig.fmap.dal.impl.expressionevaluator.DefaultExpressionEvaluator;
 import org.gvsig.fmap.dal.impl.expressionevaluator.DefaultFeatureAttributeEmulatorExpression;
-import org.gvsig.fmap.dal.impl.expressionevaluator.DefaultFeatureSymbolTable;
 import org.gvsig.fmap.dal.raster.impl.RasterStoreFactory;
 import org.gvsig.fmap.dal.raster.impl.RasterStoreOldFactory;
 import org.gvsig.fmap.dal.raster.spi.CoverageStoreProvider;
@@ -315,19 +315,45 @@
     }
 
     @Override
-    public DataStoreParameters createStoreParameters(String providerName) throws InitializeException, ProviderNotRegisteredException {
+    public DataStoreParameters createStoreParameters(String providerName, Object... arguments) throws InitializeException, ProviderNotRegisteredException {
         if( providerName == null ) {
             String msg = "Provider name can't be null.";
             LOGGER.warn(msg);
             throw new IllegalArgumentException(msg);
         }
+        if( arguments.length == 1 ) { 
+            // Desde jython entra por este metodo en lugar de los especificos
+            // de DataStoreParameters o DynObject
+            if( arguments[0] instanceof DataStoreParameters ) {
+                return this.createStoreParameters(providerName, (DataStoreParameters)(arguments[0]));
+            } else if( arguments[0] instanceof DynObject ) {
+                return this.createStoreParameters(providerName, (DynObject)(arguments[0]));
+            }
+        }
+        if( (arguments.length % 2)!= 0 ) {
+            throw new IllegalArgumentException("The number of arguments must be even.");
+        }
+        if( providerName == null ) {
+            String msg = "Provider name can't be null.";
+            LOGGER.warn(msg);
+            throw new IllegalArgumentException(msg);
+        }
         DataFactory providerFactory = this.getStoreProviderRegister().getFactory(providerName);
         if( providerFactory == null ) {
             String msg = "Can't locate provider factory for '"+providerName+"'.";
             LOGGER.warn(msg);
             throw new IllegalArgumentException(msg);
         }
-        return (DataStoreParameters) providerFactory.createParameters();
+        DataStoreParameters parameters = (DataStoreParameters) providerFactory.createParameters();
+        for( int i=0; i<arguments.length; i+=2 ) {
+            String name = (String) arguments[i];
+            if( name.endsWith("=") ) {
+                name = name.substring(0, name.length()-1);
+            }
+            Object value = arguments[i+1];
+            parameters.setDynValue(name, value);
+        }
+        return parameters;
     }
 
     @Override
@@ -989,7 +1015,7 @@
 
     @Override
     public FeatureSymbolTable createFeatureSymbolTable() {
-        FeatureSymbolTable symbolTable = new DefaultFeatureSymbolTable();
+        FeatureSymbolTable symbolTable = new FeatureSymbolTableImpl();
         return symbolTable;
     }
 
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/impl/DALDefaultImplLibrary.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/impl/DALDefaultImplLibrary.java	(revision 44737)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/impl/DALDefaultImplLibrary.java	(revision 44738)
@@ -28,12 +28,13 @@
 import java.util.List;
 import java.util.Map;
 import org.gvsig.expressionevaluator.ExpressionEvaluatorLibrary;
+import org.gvsig.expressionevaluator.impl.grammars.DataAccessGrammarFactory;
+import org.gvsig.expressionevaluator.impl.symboltable.DALSymbolTableFactory;
 
 import org.gvsig.fmap.dal.DALLibrary;
 import org.gvsig.fmap.dal.DALLocator;
 import org.gvsig.fmap.dal.DataManager;
 import org.gvsig.fmap.dal.DataTypes;
-import org.gvsig.fmap.dal.complements.Search;
 import org.gvsig.fmap.dal.feature.AbstractFeatureStoreTransform;
 import org.gvsig.fmap.dal.feature.impl.DALFile;
 import org.gvsig.fmap.dal.feature.impl.DefaultFeatureAttributeDescriptor;
@@ -58,9 +59,7 @@
 import org.gvsig.fmap.dal.feature.impl.indexes.memorybasictypes.MemoryStringIndexProviderFactory;
 import org.gvsig.fmap.dal.feature.spi.memory.MemoryResource;
 import org.gvsig.fmap.dal.feature.spi.memory.MemoryResourceParameters;
-import org.gvsig.fmap.dal.impl.expressionevaluator.DALSymbolTable;
 import org.gvsig.fmap.dal.impl.expressionevaluator.DefaultFeatureAttributeEmulatorExpression;
-import org.gvsig.fmap.dal.impl.expressionevaluator.DefaultFeatureSymbolTable;
 import org.gvsig.fmap.dal.resource.impl.DefaultResourceManager;
 import org.gvsig.fmap.dal.resource.spi.MultiResource;
 import org.gvsig.fmap.dal.resource.spi.MultiResourceParameters;
@@ -192,10 +191,10 @@
         dynObjectmanager.registerDynMethod(new ComputeAvailableValuesFromTable("getAvailableValuesFromTable", "Retrieve available values from the elements of a table."));
 
         registerTags();
-        DALSymbolTable.selfRegister();
-        DefaultFeatureSymbolTable.selfRegister();
         DefaultFeatureAttributeDescriptor.registerPersistenceDefinition();
         DefaultFeatureType.registerPersistenceDefinition();
+        DataAccessGrammarFactory.selfRegister();
+        DALSymbolTableFactory.selfRegister();
         
         if (exs.size() > 0) {
             throw new LibraryException(this.getClass(), exs);
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/impl/expressionevaluator/DefaultExpressionEvaluator.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/impl/expressionevaluator/DefaultExpressionEvaluator.java	(revision 44737)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/impl/expressionevaluator/DefaultExpressionEvaluator.java	(revision 44738)
@@ -10,6 +10,7 @@
 import org.gvsig.expressionevaluator.ExpressionEvaluatorLocator;
 import org.gvsig.expressionevaluator.ExpressionEvaluatorManager;
 import org.gvsig.expressionevaluator.Function;
+import org.gvsig.expressionevaluator.impl.symboltable.FeatureSymbolTableImpl;
 import org.gvsig.fmap.dal.expressionevaluator.ExpressionEvaluator;
 import org.gvsig.fmap.dal.expressionevaluator.FeatureSymbolTable;
 import org.gvsig.fmap.dal.feature.Feature;
@@ -19,8 +20,6 @@
 import org.gvsig.tools.evaluator.EvaluatorException;
 import org.gvsig.tools.evaluator.EvaluatorFieldsInfo;
 import org.gvsig.tools.exception.BaseException;
-import org.gvsig.tools.visitor.VisitCanceledException;
-import org.gvsig.tools.visitor.Visitor;
 import org.gvsig.tools.lang.Cloneable;
 import org.slf4j.Logger;
 import org.slf4j.LoggerFactory;
@@ -85,7 +84,7 @@
     public DefaultExpressionEvaluator(String source) {
         ExpressionEvaluatorManager manager = ExpressionEvaluatorLocator.getManager();
         this.symbolTable = manager.createSymbolTable();
-        this.featureSymbolTable = new DefaultFeatureSymbolTable();
+        this.featureSymbolTable = new FeatureSymbolTableImpl();
         this.symbolTable.addSymbolTable(this.featureSymbolTable);
         
         this.expression = manager.createExpression();
@@ -96,7 +95,7 @@
         ExpressionEvaluatorManager manager = ExpressionEvaluatorLocator.getManager();
         this.expression = expression;
         this.symbolTable = manager.createSymbolTable();
-        this.featureSymbolTable = new DefaultFeatureSymbolTable(
+        this.featureSymbolTable = new FeatureSymbolTableImpl(
 //                expression.getUserScript(), 
 //                expression.getScripts()
         );
@@ -140,14 +139,11 @@
     public EvaluatorFieldsInfo getFieldsInfo() {
         final Set<String> names = new HashSet<>();
         try {
-            this.expression.getCode().accept(new Visitor() {
-                @Override
-                public void visit(Object code) throws VisitCanceledException, BaseException {
-                    if (code instanceof Code.Identifier) {
-                        Code.Identifier identifier = (Code.Identifier) code;
-                        names.add(identifier.name());
-                    }
-                }
+            this.expression.getCode().accept((Object code) -> {
+              if (code instanceof Code.Identifier) {
+                Code.Identifier identifier = (Code.Identifier) code;
+                names.add(identifier.name());
+              }
             });
             EvaluatorFieldsInfo info = new EvaluatorFieldsInfo();
             for (String name : names) {
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/test/java/org/gvsig/expressionevaluator/TestGrammarCompiler.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/test/java/org/gvsig/expressionevaluator/TestGrammarCompiler.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/test/java/org/gvsig/expressionevaluator/TestGrammarCompiler.java	(revision 44738)
@@ -0,0 +1,251 @@
+package org.gvsig.expressionevaluator;
+
+import junit.framework.TestCase;
+import org.gvsig.tools.library.impl.DefaultLibrariesInitializer;
+
+/**
+ *
+ * @author jjdelcerro
+ */
+public class TestGrammarCompiler extends TestCase {
+
+    public TestGrammarCompiler(String testName) {
+        super(testName);
+    }
+
+    @Override
+    protected void setUp() throws Exception {
+        super.setUp();
+        new DefaultLibrariesInitializer().fullInitialize();
+    }
+
+    @Override
+    protected void tearDown() throws Exception {
+        super.tearDown();
+    }
+
+    // TODO add test methods here. The name must begin with 'test'. For example:
+    // public void testHello() {}
+    
+    protected LexicalAnalyzer createLexicalAnalyzer() {
+        ExpressionEvaluatorManager manager = ExpressionEvaluatorLocator.getManager();
+        LexicalAnalyzer lexer = manager.createLexicalAnalyzer();
+        return lexer;
+    }
+
+    protected org.gvsig.expressionevaluator.Compiler createCompiler() {
+        ExpressionEvaluatorManager manager = ExpressionEvaluatorLocator.getManager();
+        Compiler compiler = manager.createCompiler();
+        compiler.setLexicalAnalyzer(createLexicalAnalyzer());
+        return compiler;
+    }
+
+    protected SymbolTable createSymbolTable() {
+        ExpressionEvaluatorManager manager = ExpressionEvaluatorLocator.getManager();
+        MutableSymbolTable symbolTable = manager.createSymbolTable();
+        symbolTable.setVar("precio", 200);
+        symbolTable.setVar("1990", 0.168873933773767);
+        return symbolTable;
+    }
+
+    protected Interpreter createInterpreter(SymbolTable symbolTable) {
+        ExpressionEvaluatorManager manager = ExpressionEvaluatorLocator.getManager();
+        Interpreter interpreter = manager.createInterpreter();
+        interpreter.setSymbolTable(symbolTable);
+        return interpreter;
+    }
+    
+    private void link(Code code) {
+      code.link(createSymbolTable());
+    }
+
+    public void testSelect() {
+        StringBuilder source = new StringBuilder();
+        source.append("SELECT * FROM countries;");
+
+        Compiler compiler = createCompiler();
+
+        Code code = compiler.compileExpression(source.toString());
+        link(code);
+        assertEquals("SELECT(TABLE:'countries')", code.toString());
+    }
+
+    public void testSelect2() {
+        StringBuilder source = new StringBuilder();
+        source.append("BEGIN ");
+        source.append("  SET X = 0; ");
+        source.append("  FOR row in (SELECT * FROM countries;) ");
+        source.append("    BEGIN ");
+        source.append("      IF row.LASTCENSUS > 0 THEN ");
+        source.append("        SET X = X + row.LASTCENSUS ");
+        source.append("      END IF ");
+        source.append("    END FOR ");
+        source.append("END");
+
+        Compiler compiler = createCompiler();
+
+        Code code = compiler.compileExpression(source.toString());
+        link(code);
+        assertEquals("BLOCK(LET('X', 0), FOREACH('row', SELECT(TABLE:'countries'), IFF((\"row\".\"LASTCENSUS\" > 0), LET('X', (\"X\" + \"row\".\"LASTCENSUS\")))))", code.toString());
+    }
+
+    public void testSelectWhere() {
+        StringBuilder source = new StringBuilder();
+        source.append("SELECT * FROM countries  ");
+        source.append("  WHERE LASTCENSUS > 0;  ");
+
+        Compiler compiler = createCompiler();
+
+        Code code = compiler.compileExpression(source.toString());
+        link(code);
+        assertEquals("SELECT(TABLE:'countries', WHERE:(\"LASTCENSUS\" > 0))", code.toString());
+    }
+
+    public void testSelectCountWhere() {
+        StringBuilder source = new StringBuilder();
+        source.append("SELECT COUNT(*) FROM countries  ");
+        source.append("  WHERE LASTCENSUS > 0 ; ");
+
+        Compiler compiler = createCompiler();
+
+        Code code = compiler.compileExpression(source.toString());
+        link(code);
+        assertEquals("SELECT_COUNT(TABLE:'countries', WHERE:(\"LASTCENSUS\" > 0))", code.toString());
+    }
+
+    public void testSelectWhere2() {
+        StringBuilder source = new StringBuilder();
+        source.append("SELECT * FROM countries  ");
+        source.append("  WHERE countries.LASTCENSUS > 0 ; ");
+
+        Compiler compiler = createCompiler();
+
+        Code code = compiler.compileExpression(source.toString());
+        link(code);
+        assertEquals("SELECT(TABLE:'countries', WHERE:(\"countries\".\"LASTCENSUS\" > 0))", code.toString());
+    }
+
+    public void testSelectOrder() {
+        StringBuilder source = new StringBuilder();
+        source.append("SELECT * FROM countries  ");
+        source.append("  ORDER BY CONTINENT ASC, LASTCENSUS DESC; ");
+
+        Compiler compiler = createCompiler();
+
+        Code code = compiler.compileExpression(source.toString());
+        link(code);
+        assertEquals("SELECT(TABLE:'countries', ORDER1:\"CONTINENT\", ORDER2:\"LASTCENSUS\", ORDER_MODE1:TRUE, ORDER_MODE2:FALSE)", code.toString());
+    }
+
+    public void testSelectWhereOrder() {
+        StringBuilder source = new StringBuilder();
+        source.append("SELECT * FROM countries  ");
+        source.append("  WHERE LASTCENSUS > 0  ");
+        source.append("  ORDER BY ID ; ");
+
+        Compiler compiler = createCompiler();
+
+        Code code = compiler.compileExpression(source.toString());
+        link(code);
+        assertEquals("SELECT(TABLE:'countries', WHERE:(\"LASTCENSUS\" > 0), ORDER1:\"ID\", ORDER_MODE1:TRUE)", code.toString());
+    }
+
+    public void testSelectWhereOrderLimit() {
+        StringBuilder source = new StringBuilder();
+        source.append("SELECT * FROM countries  ");
+        source.append("  WHERE LASTCENSUS > 0  ");
+        source.append("  ORDER BY LASTCENSUS DESC");
+        source.append("  LIMIT 3 ;");
+
+        Compiler compiler = createCompiler();
+
+        Code code = compiler.compileExpression(source.toString());
+        link(code);
+        assertEquals("SELECT(TABLE:'countries', WHERE:(\"LASTCENSUS\" > 0), ORDER1:\"LASTCENSUS\", ORDER_MODE1:FALSE, LIMIT:3)", code.toString());
+    }
+
+    public void testSelectLimit() {
+        StringBuilder source = new StringBuilder();
+        source.append("SELECT * FROM countries  ");
+        source.append("  LIMIT 3; ");
+
+        Compiler compiler = createCompiler();
+
+        Code code = compiler.compileExpression(source.toString());
+        link(code);
+        assertEquals("SELECT(TABLE:'countries', LIMIT:3)", code.toString());
+    }
+
+    public void testExists() {
+        StringBuilder source = new StringBuilder();
+        source.append("EXISTS(NULL)");
+
+        Compiler compiler = createCompiler();
+
+        Code code = compiler.compileExpression(source.toString());
+        link(code);
+        String id = "????????????????????????????????";
+        String s = code.toString();
+        s = s.substring(0, s.length()-id.length()-2)+id+s.substring(s.length()-2);
+        assertEquals("EXISTS(NULL, '????????????????????????????????')", s);
+    }
+
+    public void testExistsSelect1() {
+        StringBuilder source = new StringBuilder();
+        source.append("EXISTS(");
+        source.append(" SELECT 1 FROM countries");
+        source.append("   WHERE countries.LASTCENSUS > 0 ; ");
+        source.append(")");
+
+        Compiler compiler = createCompiler();
+
+        Code code = compiler.compileExpression(source.toString());
+        link(code);
+        String id = "????????????????????????????????";
+        String s = code.toString();
+        s = s.substring(0, s.length()-id.length()-2)+id+s.substring(s.length()-2);
+        assertEquals("EXISTS(SELECT(TABLE:'countries', WHERE:(\"countries\".\"LASTCENSUS\" > 0)), '????????????????????????????????')", s);
+    }
+
+    public void testExistsSelectLimit1() {
+        StringBuilder source = new StringBuilder();
+        source.append("EXISTS(");
+        source.append(" SELECT 1 FROM countries  ");
+        source.append("   WHERE countries.LASTCENSUS > 0  ");
+        source.append("   LIMIT 1; ");
+        source.append(")");
+
+        Compiler compiler = createCompiler();
+
+        Code code = compiler.compileExpression(source.toString());
+        link(code);
+        String id = "????????????????????????????????";
+        String s = code.toString();
+        s = s.substring(0, s.length()-id.length()-2)+id+s.substring(s.length()-2);
+        assertEquals("EXISTS(SELECT(TABLE:'countries', WHERE:(\"countries\".\"LASTCENSUS\" > 0), LIMIT:1), '????????????????????????????????')", s);
+    }
+
+    public void testExistsSelectLimit2() {
+        // Sobre la tabla de continentes, para obtener la lista de continentes 
+        // que tienen paises sin censo.
+        // Filtramos continentes por un campo del pais.
+        StringBuilder source = new StringBuilder();
+        source.append("EXISTS(");
+        source.append(" SELECT 1 FROM countries");
+        source.append("   WHERE ");
+        source.append("     continents.NAME = countries.CONTINENT AND ");
+        source.append("     countries.LASTCENSUS < 0 ");
+        source.append("   LIMIT 1; ");
+        source.append(")");
+
+        Compiler compiler = createCompiler();
+
+        Code code = compiler.compileExpression(source.toString());
+        link(code);
+        String id = "????????????????????????????????";
+        String s = code.toString();
+        s = s.substring(0, s.length()-id.length()-2)+id+s.substring(s.length()-2);
+        assertEquals("EXISTS(SELECT(TABLE:'countries', WHERE:((\"continents\".\"NAME\" = \"countries\".\"CONTINENT\") AND (\"countries\".\"LASTCENSUS\" < 0)), LIMIT:1), '????????????????????????????????')", s);
+    }
+
+}
